unit mainU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

const
  MaxElements = 100;
  cellsize = 25;
  cellcount = 9;
type
  SDigits = 1..9;
  TArray2D = array[0..MaxElements - 1, 0..MaxElements - 1] of Integer;

  TField = record
    System  : Boolean;
    Value   : Integer;
  end;
  TMyField = array [0..8,0..8] of TField;
  TmainF = class(TForm)
    fieldI: TImage;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    sysField : TmyField;
    stop : Boolean;
    procedure DrawMyGrid(cnv : TCanvas);
    procedure ShowStartVals(ok : TmyField; cnv : TCanvas);
    procedure FillUnique(var A: TArray2D; W, H: Integer);
  end;

const
  ArrWidth  = 9;
  ArrHeight = 9;
var
  A: TArray2D;
  ADgts : Array [0..2,0..2] of set of SDigits;

  mainF: TmainF;

implementation

{$R *.dfm}

{ TmainF }

procedure TmainF.Button1Click(Sender: TObject);
var
  I, J: Integer;
begin
  Randomize();
  //    
  for J := 1 to ArrWidth do
    for I := 1 to ArrHeight do
      A[J - 1, I - 1] := -1;
  //  
  for J := 0 to 2 do
    for I := 0 to 2 do
      ADgts[J,I] := [];
  //  
  FillUnique(A, ArrWidth, ArrHeight);

  //    
    for J := 0 to ArrWidth - 1 do
    for I := 0 to ArrHeight - 1 do
    begin
      sysField[j, i].System := true;
      sysField[j, i].Value := A[J, I];
    end;
  //  
  fieldI.Width := cellsize * 9;
  fieldI.Height := cellsize * 9;
  DrawMyGrid(fieldI.Canvas);
  ShowStartVals(sysField, fieldI.Canvas);
end;

procedure TmainF.DrawMyGrid(cnv: TCanvas);
var
  i : integer;
begin
  //Clear
  cnv.Brush.Color := clSilver;
  cnv.FillRect(Rect(0,0,280,280));

  //Bold lines
  cnv.Pen.Color := 0;
  cnv.Pen.Width := 3;

  cnv.MoveTo(cellsize * 3, 0);
  cnv.LineTo(cellsize * 3,cellsize * 9);
  cnv.MoveTo(cellsize * 6,0);
  cnv.LineTo(cellsize * 6,cellsize * 9);

  cnv.MoveTo(0, cellsize * 3);
  cnv.LineTo(cellsize * 9,cellsize * 3);
  cnv.MoveTo(0,cellsize * 6);
  cnv.LineTo(cellsize * 9,cellsize * 6);

  //Thin lines
  cnv.Pen.Width := 0;

  for i := 1 to 8 do begin
    cnv.MoveTo(i*cellsize,0);
    cnv.LineTo(i*cellsize,cellsize * 9);

    cnv.MoveTo(0,i*cellsize);
    cnv.LineTo(cellsize * 9,i*cellsize);
  end;
end;

procedure TmainF.ShowStartVals(ok: TmyField; cnv: TCanvas);
var
  x,y,ax,ay : integer;
  wid, hei : Integer;
begin
  cnv.Font.Style := [fsBold];
  cnv.Font.Size := 10;
  for x := 0 to 8 do
    for y := 0 to 8 do begin
      if ok[x,y].System then cnv.Font.Color := clMaroon
                             else cnv.Font.Color := clGreen;
      if ok[x,y].Value <> -1 then
      begin
        ax := cellsize*x + (cellsize - cnv.TextWidth(inttostr(ok[x,y].Value))) div 2;
        ay := cellsize*y + (cellsize - cnv.TextHeight(inttostr(ok[x,y].Value))) div 2;
        wid := (cellsize - cnv.TextWidth(inttostr(ok[x,y].Value))) div 2;
        hei := (cellsize - cnv.TextHeight(inttostr(ok[x,y].Value))) div 2;
        cnv.TextOut(ax,ay,inttostr(ok[x,y].Value));
      end;
    end;
end;

procedure TmainF.FillUnique(var A: TArray2D; W, H: Integer);
var
  StartInit, Vector: array[0..MaxElements - 1] of Integer;
  I, J, R: Integer;

  procedure Exchange(N, M: Integer);
  var
    Element: Integer;
  begin
    Element := Vector[N];
    Vector[N] := Vector[M];
    Vector[M] := Element;
  end;

 function ElementAlreadyInColumn(Element, ColumnIndex, MaxRowIndexToCheck: Integer): Boolean;
  var
    Y: Integer;
  begin
    for Y := 0 to MaxRowIndexToCheck do
      if (A[ColumnIndex, Y] = Element) then
      begin
        Result := true;
        Exit;
      end;
    Result := false;
  end;
  //  -       
  function ElementAlreadyInSquare(Element, ColumnIndex, RowIndex: Integer): Boolean;
  var
    ci, ri : Integer;
  begin
    Result := false;
    ci := ColumnIndex div 3;
    ri := RowIndex div 3;
    if Element in ADgts[ci,ri] then
      Result := True;
  end;
begin
  //       ,
  //         .
  // ,     ,
  //        *scratching_*
  for J := 0 to (W - 1) do
    StartInit[J] := J + 1;
  for I := 0 to (H - 1) do
  begin
    //          
    Move(StartInit, Vector, W * sizeof(Integer));
    //     
    for J := 0 to (W - 3) do
    begin
      R := J + 1;
      Exchange(J, Random(W - R) + R);
    end;

    for J := 0 to (W - 1) do
    begin
      R := J + 1;
     //        ,   
     //        
//      while (ElementAlreadyInColumn(Vector[J], J, I - 1) and (R < W)) do
      while (ElementAlreadyInSquare(Vector[J], J, I-1) and (R < W))  do
      begin
        Exchange(J, R);
        Inc(R);
      end;
      A[J, I] := Vector[J];
      //      
      Include(ADgts[J div 3, I div 3], Vector[J]);
    end;
  end;
end;

procedure TmainF.FormCreate(Sender: TObject);
begin
  DrawMyGrid(fieldI.Canvas);
end;

end.
